<template>
	<v-form ref="form"
			v-model="valid">

		<v-text-field :counter="15"
					  :rules="getXRules"
					  label="X"
					  required
					  v-model="x_input"/>

		<v-text-field :counter="15"
					  :rules="getYRules"
					  label="Y"
					  required
					  v-model="y_input"/>

		<v-text-field :counter="15"
					  :rules="getRRules"
					  label="R"
					  required
					  v-model="r_input"/>

		<v-btn :disabled="!valid"
			   @click="validate"
			   class="mr-4"
			   color="success">
			Send
		</v-btn>

		<v-btn @click="reset"
			   class="mr-4"
			   color="error">
			Reset Form
		</v-btn>
	</v-form>
</template>

<script>
    import {isNumber, validateRange} from "../../../utils/utils";
    import {mapActions, mapGetters, mapMutations, mapState} from "vuex";
    import graphics from "../../../api/graphics";

    export default {
        name: "FormComponent",
        data() {
            return {
                valid: true,
                x_input: '',
                y_input: '',
                r_input: '1',
            };
        },
        watch: {
            r_input: function (newV, oldV) {
                if (newV && isNumber(newV) && validateRange(newV, 0, 3)) {
                    this.graphics.changeGraphicsRadius(newV);
                    newV = newV.replace('.',',');
                    this.recountPointsRadius(newV);
                    this.updateRadiusMutation(newV);
                }
            }
        },
        computed: {
            ...mapState(["graphics"]),
            ...mapGetters(["getXRules", "getYRules", "getRRules"])
        },
        methods: {
            ...mapMutations(["updateRadiusMutation"]),
            ...mapActions(["addPointAction", "recountPointsRadius"]),
            validate() {
                if (this.$refs.form.validate()) {
                    this.resetValidation();
                    let data = {x: this.x_input, y: this.y_input, r: this.r_input};
                    this.addPointAction(data);
                    this.reset();
                }
            },
            reset() {
                this.$refs.form.reset()
            },

            resetValidation() {
                this.$refs.form.resetValidation()
            },
        }
    }
</script>

<style scoped>

</style>